queue <- []
isBlocked <- false
blockDuration <- 3

function handleArrival(scope) { // Put the robot in a queue to pass
    if (isBlocked) {
        queue.push({scope = scope, deathsWhenJoinedQueue = scope.deaths})
		// Get the destination out of the way, this prevents the OnPass from
		// triggering multiple times before it is teleported to the next destination.
		scope.robotDestination.SetAbsOrigin(self.GetOrigin()+Vector(0,0,666))
        // Also set the target to null as an extra layer of -anti retrigger- security
        scope.robotDestinationScope.target = null
    }
    else {
        giveGoAhead(scope)
        Block()
    }
}

function Block() {
    isBlocked = true
    EntFireByHandle(self, "RunScriptCode", "OnTimeout()", blockDuration, null, null)
}

function OnTimeout() {
    if (queue.len() == 0) {
        isBlocked = false
    }
    else {
        local head = queue[0]
        while (head.scope.deaths > head.deathsWhenJoinedQueue) {
            queue.remove(0)
            if (queue.len() == 0) {
                isBlocked = false
                return
            }
            head = queue[0]
        }
        giveGoAhead(head.scope)
        EntFireByHandle(self, "RunScriptCode", "OnTimeout()", blockDuration, null, null)
        queue.remove(0)
    }
}

function giveGoAhead(scope) {
    scope.GoTo(NetProps.GetPropEntity(self, "m_pnext"))
}

function handleTeleport(scope, silent) {
    if (silent) {
        scope.robot.SetAbsOrigin(self.GetOrigin())
    }
    else {
        playParticle(scope.teamNum == 2 ? "electrocuted_gibbed_red" : "electrocuted_gibbed_blue",0)
        playParticle(scope.teamNum == 2 ? "electrocuted_gibbed_red" : "electrocuted_gibbed_blue",0)
        playParticle(scope.teamNum == 2 ? "teleportedin_red" : "teleportedin_blue",2)
        scope.pendingTeleportLocation <- self
        EntFireByHandle(scope.self, "RunScriptCode", "robot.SetAbsOrigin(pendingTeleportLocation.GetOrigin())", 2, null, null)
    }
}

function playParticle(particle, delay) {
    EntFireByHandle(self, "RunScriptCode", "DispatchParticleEffect(`"+particle+"`, self.GetOrigin(), Vector(0,0,0))" , delay, null, null)
}